# Version impérative 

def noyau_imp(L: list[set[int]]) -> set[int]:
    S = set(L[0])
    for S2 in L[1:]:
        new_S = set()
        for x in S:
            if x in S2:
                new_S.add(x)
        S = new_S
    return S

def noyau_imp2(L: list[set[int]]) -> set[int]:
    S = set(L[0])
    for S2 in L[1:]:
        S = S.intersection(S2)
    return S

def noyau_rec(L: list[set[int]]) -> set[int]:
    if len(L) == 1:
        return L[0]
    return L[0].intersection(noyau_rec(L[1:]))

    K = set()
    for x in noyau(L[1:]):
        if x in L[0]:
            K.add(x)
    return K
    

def _noyau_rec2(L: list[set[int]], index_start:int) -> set[int]:
    if index_start == len(L) - 1:
        return L[index_start]
    return L[index_start].intersection(_noyau_rec2(L, index_start+1))


def noyau_rec2(L: list[set[int]]) -> set[int]:
    return _noyau_rec2(L, 0)

from functools import reduce

def noyau3(L: list[set[int]]) -> set[int]:
    return reduce(lambda x,y: x.intersection(y), L[1:], L[0])


# Sous-ensemble:

def sous_ensemble(S : set[int]) -> list[set[int]]:
    if len(S) == 0:
        return [ set() ]

    Sx = set([next(iter(S))]) # ensemble qui contient x

    S2 = S - Sx# l'ensemble S sans x

    L = sous_ensemble(S2)
    K = []
    for S in L:
        K.append(S + Sx)
    L.extend(K)
    # L.extend veut dire:
    # for t in K:
    #     L.append(t)

    # ça ne marche pas:
    for S in L:
        L.append(S + Sx) 

    # mais ça ça marche:
    for S in L[:]:
        L.append(S + Sx) 

    return L


def sous_ensemble(S : set[int]) -> list[set[int]]:
    if len(S) == 0:
        return [ set() ]
    cS = set(S)
    x = S.pop()
    L = sous_ensemble(cS)
    K = []
    for S in L:
        K.append(S + set([x]))
    L.extend(K)
    return L


